#!/bin/bash
set -x

# create new minikube instance with standalone config (embedded certs like kubeadm creates)
# sudo minikube start --vm-driver none --embed-certs
# BUT! there's a bug for driver=none that prevents embedding certs (https://github.com/kubernetes/minikube/issues/5716)
# workaround is to create linked certs and embed certs manually
#CHANGE_MINIKUBE_NONE_USER=true
sudo minikube start --vm-driver none

# change owners for minikube and kubectl files
sudo chown -R ubuntu:ubuntu ~/.minikube ~/.kube

## recreate config to manually embed certs
kubectl config set-credentials minikube --client-certificate=$HOME/.minikube/apiserver.crt --client-key=$HOME/.minikube/apiserver.key --embed-certs
kubectl config set-cluster minikube --certificate-authority=$HOME/.minikube/ca.crt --embed-certs

###
### Now exit and login back again.
### 

echo Now exit and login back again.
echo You can also copy .kube/config to some other machine, if you want remote access to this minikube cluster.
